diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/ht/ht-phy.cc ns-3.43/src/wifi/model/ht/ht-phy.cc
--- ns-3.42/src/wifi/model/ht/ht-phy.cc	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/ht/ht-phy.cc	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Orange Labs
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Rediet <getachew.redieteab@orange.com>
  *          Sébastien Deronne <sebastien.deronne@gmail.com> (for logic ported from wifi-phy)
@@ -366,16 +355,17 @@
      * were obtained by observing the rates for which Nes was incremented in tables
      * 19-27 to 19-41 of IEEE 802.11-2016.
      */
-    double maxRatePerCoder = (txVector.GetGuardInterval() == 800) ? 320e6 : 350e6;
+    double maxRatePerCoder = (txVector.GetGuardInterval().GetNanoSeconds() == 800) ? 320e6 : 350e6;
     return ceil(txVector.GetMode().GetDataRate(txVector) / maxRatePerCoder);
 }
 
 Time
 HtPhy::GetSymbolDuration(const WifiTxVector& txVector) const
 {
-    uint16_t gi = txVector.GetGuardInterval();
+    const auto guardInterval = txVector.GetGuardInterval();
+    [[maybe_unused]] const auto gi = guardInterval.GetNanoSeconds();
     NS_ASSERT(gi == 400 || gi == 800);
-    return NanoSeconds(3200 + gi);
+    return GetSymbolDuration(guardInterval);
 }
 
 Ptr<WifiPpdu>
@@ -460,17 +450,18 @@
 }
 
 Ptr<SpectrumValue>
-HtPhy::GetTxPowerSpectralDensity(double txPowerW, Ptr<const WifiPpdu> ppdu) const
+HtPhy::GetTxPowerSpectralDensity(Watt_u txPower, Ptr<const WifiPpdu> ppdu) const
 {
+    const auto& centerFrequencies = ppdu->GetTxCenterFreqs();
+    NS_ASSERT(centerFrequencies.size() == 1);
     const auto& txVector = ppdu->GetTxVector();
-    uint16_t centerFrequency = GetCenterFrequencyForChannelWidth(txVector);
-    uint16_t channelWidth = txVector.GetChannelWidth();
-    NS_LOG_FUNCTION(this << centerFrequency << channelWidth << txPowerW);
+    const auto channelWidth = txVector.GetChannelWidth();
+    NS_LOG_FUNCTION(this << centerFrequencies.front() << channelWidth << txPower);
     const auto& txMaskRejectionParams = GetTxMaskRejectionParams();
-    Ptr<SpectrumValue> v = WifiSpectrumValueHelper::CreateHtOfdmTxPowerSpectralDensity(
-        centerFrequency,
+    auto v = WifiSpectrumValueHelper::CreateHtOfdmTxPowerSpectralDensity(
+        centerFrequencies,
         channelWidth,
-        txPowerW,
+        txPower,
         GetGuardBandwidth(channelWidth),
         std::get<0>(txMaskRejectionParams),
         std::get<1>(txMaskRejectionParams),
@@ -649,10 +640,10 @@
 }
 
 uint64_t
-HtPhy::GetPhyRate(uint8_t mcsValue, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss)
+HtPhy::GetPhyRate(uint8_t mcsValue, MHz_u channelWidth, Time guardInterval, uint8_t nss)
 {
-    WifiCodeRate codeRate = GetHtCodeRate(mcsValue);
-    uint64_t dataRate = GetDataRate(mcsValue, channelWidth, guardInterval, nss);
+    const auto codeRate = GetHtCodeRate(mcsValue);
+    const auto dataRate = GetDataRate(mcsValue, channelWidth, guardInterval, nss);
     return CalculatePhyRate(codeRate, dataRate);
 }
 
@@ -693,11 +684,12 @@
 }
 
 uint64_t
-HtPhy::GetDataRate(uint8_t mcsValue, uint16_t channelWidth, uint16_t guardInterval, uint8_t nss)
+HtPhy::GetDataRate(uint8_t mcsValue, MHz_u channelWidth, Time guardInterval, uint8_t nss)
 {
-    NS_ASSERT(guardInterval == 800 || guardInterval == 400);
+    [[maybe_unused]] const auto gi = guardInterval.GetNanoSeconds();
+    NS_ASSERT((gi == 800) || (gi == 400));
     NS_ASSERT(nss <= 4);
-    return CalculateDataRate(GetSymbolDuration(NanoSeconds(guardInterval)),
+    return CalculateDataRate(GetSymbolDuration(guardInterval),
                              GetUsableSubcarriers(channelWidth),
                              static_cast<uint16_t>(log2(GetHtConstellationSize(mcsValue))),
                              GetCodeRatio(GetHtCodeRate(mcsValue)),
@@ -718,7 +710,7 @@
 }
 
 uint16_t
-HtPhy::GetUsableSubcarriers(uint16_t channelWidth)
+HtPhy::GetUsableSubcarriers(MHz_u channelWidth)
 {
     return (channelWidth == 40) ? 108 : 52;
 }
@@ -732,8 +724,8 @@
 uint64_t
 HtPhy::GetNonHtReferenceRate(uint8_t mcsValue)
 {
-    WifiCodeRate codeRate = GetHtCodeRate(mcsValue);
-    uint16_t constellationSize = GetHtConstellationSize(mcsValue);
+    const auto codeRate = GetHtCodeRate(mcsValue);
+    const auto constellationSize = GetHtConstellationSize(mcsValue);
     return CalculateNonHtReferenceRate(codeRate, constellationSize);
 }
 
@@ -828,8 +820,8 @@
     {
         return OfdmPhy::GetCcaIndication(ppdu);
     }
-    double ccaThresholdDbm = GetCcaThreshold(ppdu, WIFI_CHANLIST_PRIMARY);
-    Time delayUntilCcaEnd = GetDelayUntilCcaEnd(ccaThresholdDbm, GetPrimaryBand(20));
+    auto ccaThreshold = GetCcaThreshold(ppdu, WIFI_CHANLIST_PRIMARY);
+    auto delayUntilCcaEnd = GetDelayUntilCcaEnd(ccaThreshold, GetPrimaryBand(20));
     if (delayUntilCcaEnd.IsStrictlyPositive())
     {
         return std::make_pair(
@@ -838,11 +830,11 @@
     }
     if (ppdu)
     {
-        const uint16_t primaryWidth = 20;
-        uint16_t p20MinFreq =
+        const MHz_u primaryWidth = 20;
+        const MHz_u p20MinFreq =
             m_wifiPhy->GetOperatingChannel().GetPrimaryChannelCenterFrequency(primaryWidth) -
             (primaryWidth / 2);
-        uint16_t p20MaxFreq =
+        const MHz_u p20MaxFreq =
             m_wifiPhy->GetOperatingChannel().GetPrimaryChannelCenterFrequency(primaryWidth) +
             (primaryWidth / 2);
         if (ppdu->DoesOverlapChannel(p20MinFreq, p20MaxFreq))
@@ -855,17 +847,17 @@
         }
     }
 
-    const uint16_t secondaryWidth = 20;
-    uint16_t s20MinFreq =
+    const MHz_u secondaryWidth = 20;
+    const MHz_u s20MinFreq =
         m_wifiPhy->GetOperatingChannel().GetSecondaryChannelCenterFrequency(secondaryWidth) -
         (secondaryWidth / 2);
-    uint16_t s20MaxFreq =
+    const MHz_u s20MaxFreq =
         m_wifiPhy->GetOperatingChannel().GetSecondaryChannelCenterFrequency(secondaryWidth) +
         (secondaryWidth / 2);
     if (!ppdu || ppdu->DoesOverlapChannel(s20MinFreq, s20MaxFreq))
     {
-        ccaThresholdDbm = GetCcaThreshold(ppdu, WIFI_CHANLIST_SECONDARY);
-        delayUntilCcaEnd = GetDelayUntilCcaEnd(ccaThresholdDbm, GetSecondaryBand(20));
+        ccaThreshold = GetCcaThreshold(ppdu, WIFI_CHANLIST_SECONDARY);
+        delayUntilCcaEnd = GetDelayUntilCcaEnd(ccaThreshold, GetSecondaryBand(20));
         if (delayUntilCcaEnd.IsStrictlyPositive())
         {
             return std::make_pair(delayUntilCcaEnd, WIFI_CHANLIST_SECONDARY);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/ht/ht-phy.h ns-3.43/src/wifi/model/ht/ht-phy.h
--- ns-3.42/src/wifi/model/ht/ht-phy.h	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/ht/ht-phy.h	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Orange Labs
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Rediet <getachew.redieteab@orange.com>
  *          Sébastien Deronne <sebastien.deronne@gmail.com> (for logic ported from wifi-phy)
@@ -396,15 +385,15 @@
      * and is mainly used as a callback for WifiMode operation.
      *
      * \param mcsValue the HT MCS index
-     * \param channelWidth the considered channel width in MHz
-     * \param guardInterval the considered guard interval duration in nanoseconds
+     * \param channelWidth the considered channel width
+     * \param guardInterval the considered guard interval duration
      * \param nss the considered number of stream
      *
      * \return the physical bit rate of this signal in bps.
      */
     static uint64_t GetPhyRate(uint8_t mcsValue,
-                               uint16_t channelWidth,
-                               uint16_t guardInterval,
+                               MHz_u channelWidth,
+                               Time guardInterval,
                                uint8_t nss);
     /**
      * Return the PHY rate corresponding to
@@ -435,14 +424,14 @@
      * callback for WifiMode operation.
      *
      * \param mcsValue the HT MCS index
-     * \param channelWidth the channel width in MHz
+     * \param channelWidth the channel width
      * \param guardInterval the guard interval duration in nanoseconds
      * \param nss the number of spatial streams
      * \return the data bit rate in bps.
      */
     static uint64_t GetDataRate(uint8_t mcsValue,
-                                uint16_t channelWidth,
-                                uint16_t guardInterval,
+                                MHz_u channelWidth,
+                                Time guardInterval,
                                 uint8_t nss);
     /**
      * Calculate the rate in bps of the non-HT Reference Rate corresponding
@@ -466,7 +455,7 @@
     PhyFieldRxStatus DoEndReceiveField(WifiPpduField field, Ptr<Event> event) override;
     bool IsAllConfigSupported(WifiPpduField field, Ptr<const WifiPpdu> ppdu) const override;
     bool IsConfigSupported(Ptr<const WifiPpdu> ppdu) const override;
-    Ptr<SpectrumValue> GetTxPowerSpectralDensity(double txPowerW,
+    Ptr<SpectrumValue> GetTxPowerSpectralDensity(Watt_u txPower,
                                                  Ptr<const WifiPpdu> ppdu) const override;
     uint32_t GetMaxPsduSize() const override;
     CcaIndication GetCcaIndication(const Ptr<const WifiPpdu> ppdu) override;
@@ -538,16 +527,10 @@
                                       uint8_t nss);
 
     /**
-     * \param channelWidth the channel width in MHz
-     * \return the symbol duration excluding guard interval
-     */
-    static Time GetSymbolDuration(uint16_t channelWidth);
-
-    /**
-     * \param channelWidth the channel width in MHz
+     * \param channelWidth the channel width
      * \return the number of usable subcarriers for data
      */
-    static uint16_t GetUsableSubcarriers(uint16_t channelWidth);
+    static uint16_t GetUsableSubcarriers(MHz_u channelWidth);
 
     /**
      * \param guardInterval the guard interval duration
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/ht/ht-ppdu.cc ns-3.43/src/wifi/model/ht/ht-ppdu.cc
--- ns-3.42/src/wifi/model/ht/ht-ppdu.cc	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/ht/ht-ppdu.cc	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Orange Labs
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Rediet <getachew.redieteab@orange.com>
  *         Muhammad Iqbal Rochman <muhiqbalcr@uchicago.edu>
@@ -82,7 +71,7 @@
     htSig.SetChannelWidth(txVector.GetChannelWidth());
     htSig.SetHtLength(psduSize);
     htSig.SetAggregation(txVector.IsAggregation());
-    htSig.SetShortGuardInterval(txVector.GetGuardInterval() == 400);
+    htSig.SetShortGuardInterval(txVector.GetGuardInterval().GetNanoSeconds() == 400);
 }
 
 WifiTxVector
@@ -102,7 +91,7 @@
     txVector.SetMode(HtPhy::GetHtMcs(htSig.GetMcs()));
     txVector.SetChannelWidth(htSig.GetChannelWidth());
     txVector.SetNss(1 + (htSig.GetMcs() / 8));
-    txVector.SetGuardInterval(htSig.GetShortGuardInterval() ? 400 : 800);
+    txVector.SetGuardInterval(NanoSeconds(htSig.GetShortGuardInterval() ? 400 : 800));
     txVector.SetAggregation(htSig.GetAggregation());
 }
 
@@ -144,12 +133,12 @@
 }
 
 void
-HtPpdu::HtSigHeader::SetChannelWidth(uint16_t channelWidth)
+HtPpdu::HtSigHeader::SetChannelWidth(MHz_u channelWidth)
 {
     m_cbw20_40 = (channelWidth > 20) ? 1 : 0;
 }
 
-uint16_t
+MHz_u
 HtPpdu::HtSigHeader::GetChannelWidth() const
 {
     return m_cbw20_40 ? 40 : 20;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/ht/ht-ppdu.h ns-3.43/src/wifi/model/ht/ht-ppdu.h
--- ns-3.42/src/wifi/model/ht/ht-ppdu.h	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/ht/ht-ppdu.h	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Orange Labs
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Rediet <getachew.redieteab@orange.com>
  *         Muhammad Iqbal Rochman <muhiqbalcr@uchicago.edu>
@@ -66,17 +55,17 @@
          */
         uint8_t GetMcs() const;
         /**
-         * Fill the channel width field of HT-SIG (in MHz).
+         * Fill the channel width field of HT-SIG.
          *
-         * \param channelWidth the channel width (in MHz)
+         * \param channelWidth the channel width
          */
-        void SetChannelWidth(uint16_t channelWidth);
+        void SetChannelWidth(MHz_u channelWidth);
         /**
-         * Return the channel width (in MHz).
+         * Return the channel width.
          *
-         * \return the channel width (in MHz)
+         * \return the channel width
          */
-        uint16_t GetChannelWidth() const;
+        MHz_u GetChannelWidth() const;
         /**
          * Fill the aggregation field of HT-SIG.
          *
